
;****************************************************
;
;******************* YOU HAVE MAIL RECEIVER *****************
;
;
;****************************************************
  

;05/20/2013
;XTAL 4 MHz
;USE RS232 2400 BAUD 

;05/30/2013 N&V


;PIN 1 VCC
;PIN 2 RB5 	  RED  
;PIN 3 RB4    LATCH                  
;PIN 4 RB3    SERIAL IN DATA STREAM
;PIN 5 RB2    RESET_SWITCH     
;PIN 6 RB1	  SPEAKER
;PIN 7 RB0	  GREEN
;PIN 8 VSS
	RADIX		HEX	;HEX IS DEFAULT # FORMAT
    list      p=12F508            ; list directive to define processor
    #include <p12F508.inc>        ; processor specific variable definitions

    __CONFIG   _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC
 
TEMP           	EQU		07H		  	;WORKING REGISTER
DELAY_CNTR     	EQU     08H       	;COUNTING REGISTER FOR RS232
BIT_CNTR1     	EQU     09H       	;COUNTING REGISTER FOR RS232
BIT_CNTR       	EQU     0AH       	;COUNTING REGISTER FOR RS232
RCV_BYTE       	EQU     0BH       	;TRANSFER REGISTER FOR RS232
RCV_BYTE1      	EQU     0CH       	;TRANSFER REGISTER FOR RS232
KEY1		   	EQU		0DH			;KEY 1 FOR RECEIVER
KEY2			EQU		0EH			;KEY 2 FOR RECEIVER
KEY1TRANS		EQU		0FH			;RECEIVED KEY 1 FROM TRANSMITTER
KEY2TRANS		EQU		10H			;RECEIVED KEY 1 FROM TRANSMITTER
FLAGS			EQU		11H			;FLAG REGISTER
COUNT			EQU		12H			;COUNTING REGISTER
COUNT1			EQU		13H			;COUNTING REGISTER
COUNT2			EQU		14H			;COUNTING REGISTER
COUNT3			EQU		015H		;COUNTING REGISTER
COUNT4			EQU		016H		;COUNTING REGISTER
COUNT5			EQU		017H		;COUNTING REGISTER

#DEFINE		   GREEN		GPIO,0		;GREEN LED
#DEFINE		   OUT			GPIO,1		;SPEAKER OUT
#DEFINE		   RESET_SWITCH GPIO,2		;RESET SWITCH
#DEFINE		   SERIAL_IN    GPIO,3     	;RS232 TRANSMIT DATA
#DEFINE		   LATCH		GPIO,4		;OUTPUT FOR LATCH LED
#DEFINE		   RED			GPIO,5		;RED LED

#DEFINE		   FLAG			FLAGS,0		;FLAG FOR LATCH



		ORG	00H

MAIN    	MOVWF   	OSCCAL            ; update register with factory cal value 

;********INPUT KEY 1 IN HEXIDECIMAL E.G.0A1H
			MOVLW		B'10101010'	;LOADING KEY 1
			MOVWF		KEY1		;LOAD
;********INPUT LAST 4 BITS KEY 2 IN HEXIDECIMAL E.G., 0A0H  (ZERO MUST PRECEED ANY LETTER)
			MOVLW		0F8H		;LOADING KEY 2
 		    MOVWF		KEY2		;LOAD

AWAYWEGO							;LABLE
      	  	CLRF		GPIO		;CLEAR PINS
		  	MOVLW		B'00001100'	;LOAD PINS FOR IN AND OUT  
		  	TRIS		GPIO		;LOAD
			MOVLW		B'10011111'	;LOADING OPTION REGISTER
			OPTION					;LOAD



	
START
CHECK	BTFSC	RESET_SWITCH		;CHECK RESET SWITCH FOR BEING PUSHED
		GOTO	C0					;NOT PUSHED JUMP TO C0
		MOVLW	.10					;LOADING DELAY
		MOVWF	COUNT3
CA		BTFSC	RESET_SWITCH		;CHECK RESET SWITCH RELEASE
		GOTO	CB					;RELEASE JUMP
		DECFSZ	COUNT1,1
		GOTO	CA
		DECFSZ	COUNT2,1
		GOTO	CA
		DECFSZ	COUNT3,1
		GOTO	CA
		BTFSS	FLAGS,0				;TOGGLE CHECK FLAGS STATUS
		GOTO	CC					;LOW JUMP
		BCF		FLAGS,0				;HIGH CLEAR FLAGS
		BCF		LATCH				;CLEAR LATCH
		GOTO	C0					;JUMP
CC		BSF		FLAGS,0				;FLAGS LOW SET FLAGS
		BSF		LATCH				;SET LATCH 
		GOTO	C0					;JUMP

CB		BSF		GREEN				;RESET TO GREEN
		BCF		RED
		

C0		MOVLW		.10				;TIME DELAY
		MOVWF		COUNT4	
C2	    BTFSS		SERIAL_IN		;MAKE SURE SERIAL IN IS HIGH FOR A PERIOD OF TIME INDICATING TRANSMITER SIGNAL
		GOTO		CHECK			;NOT HIGH GO TO CHECK
		DECFSZ		COUNT3,1		;TIMING FOR TRANSMITTER ON
		GOTO		C2				;TIMER
		DECFSZ		COUNT4,1		;TIMER	
		GOTO		C2				;TIMER
	  	BTFSC		SERIAL_IN		;CHECK FOR DATA SIGNAL FROM TRANSMITTER
		GOTO		$-1				;NO DATA
		

C1		CALL		START_DELAY		;DATE CHECKING TO SEE IF VALID
		BTFSC		SERIAL_IN		;STILL LOW?
		GOTO		CHECK			;NO GO BACK TO CHECK



		MOVLW		.8				;LOAD BIT COUNTER
		MOVWF		BIT_CNTR		;LOAD
		CLRF		RCV_BYTE		;CLEAR RCV BYTE
NEXT_RCVBIT							;LABEL
		CALL		BIT_DELAY		;CALLING BIT DELAY
		BTFSS		SERIAL_IN		;IS DATA IN HIGH?
		BCF			STATUS,C		;NO CLEAR STATUS C
		BTFSC		SERIAL_IN		;IS DATE LOW?
		BSF			STATUS,C		;NO SET STATUS C
		RRF			RCV_BYTE,1		;ROTATE RECEIVE BYTE OUT
		DECFSZ		BIT_CNTR,1		;CHECK TO SEE IF 8 BIT SENT
		GOTO		NEXT_RCVBIT		;NOT 8 DO AGAIN

NB		MOVF		RCV_BYTE,W		;DONE MOVE RECEIVE BYTE INTO KEY1TRANS
		MOVWF		KEY1TRANS		;LOAD
		MOVLW		.8				;RESET BIT COUNTER
		MOVWF		BIT_CNTR		;LOAD
		CLRF		RCV_BYTE1		;CLEAR RECEIVE BYTE 1

NEXT_RCVBIT1						;LABEL
		CALL		BIT_DELAY		;CALL BIT DELAY
		BTFSS		SERIAL_IN		;CHECK SERIAL IN
		BCF			STATUS,C		;LOW CLEAR STATUS C
		BTFSC		SERIAL_IN		;CHECK SERIAL IN
		BSF			STATUS,C		;HIGH SET STATUS C
		RRF			RCV_BYTE1,1		;ROTATE BIT OUT
		DECFSZ		BIT_CNTR,1		;CHECK FOR 8 BITS
		GOTO		NEXT_RCVBIT1	;NOT 8 BITS DO AGAIN
		CALL		BIT_DELAY		;CALL BIT DELAY
		MOVF		RCV_BYTE1,W		;MOVING RECEIVE BYTE INTO KEY2TRANS
		MOVWF		KEY2TRANS		;LOAD
		GOTO		DECODE			;GO TO DECODE
      
;********************RS232 INSTRUCTIONS***********
       
BIT_DELAY 
		MOVLW		D'200'		    ;SETUP FOR 1200 BAUD
		MOVWF		DELAY_CNTR      ;DELAY LOOP
LOOP_1  NOP							;DELAY HELP
		DECFSZ  	DELAY_CNTR,1	;DECREASING COUNTER		
		GOTO		LOOP_1    		;DECREASE COUNTER
		RETLW 	    0               ;RETURN TO CALL

START_DELAY							;LABEL
		MOVLW		D'100'		   	;SETUP FOR 1200 BAUD SETS FOR DETECTING MIDDLE OF BIT
		MOVWF		DELAY_CNTR	   	;DELAY LOOP
		
LOOP_2	NOP							;DELAY HELP
		DECFSZ		DELAY_CNTR,1	;DECREASEING COUNTER
	    GOTO		LOOP_2          ;DECREASE COUNTER
        RETLW 		0              	;RETURN TO CALL
 
DECODE								;LABEL
;*****************CHECKING KEY ONE***************
		MOVF		KEY1,0			;MOVE KEY1 INTO W
		SUBWF		KEY1TRANS,0		;SUBTRACT TRANSMITTED KEY
		BTFSC		3,2				;CHECK TO SEE IF IDENTICAL
		GOTO		D1				;IDENTICAL GO TO D1
		GOTO		CHECK			;DID NOT MATCH START OVER

D1		BSF			RED				;TURN LED TO RED
		BCF			GREEN
	
		BTFSS		FLAGS,0			;CHECK FLAGS
		GOTO		ALARM2			;FLAGS LOW JUMP TO ALARM 2
	    
ALARM	  MOVLW		.45					;THIS SET THE TIME FOR ALARMING
		  MOVWF		COUNT2				;LOAD

ALARM1	  BCF		OUT					;TURN ON SPEAKER
		  CALL		BUZZ				;DELAY
		  BSF		OUT					;TURN OFF SPEAKER
		  CALL		BUZZ				;DELAY
		  DECFSZ	COUNT1,1			;ALARM FOR 5 SECONDS
		  GOTO		ALARM1				;JUMP
		  DECFSZ	COUNT2,1			;DELAY
		  GOTO		ALARM1				;REPEAT
		  BSF		OUT				    ;TURN OFF SPEAKER
		  GOTO		CHECK				;RETURN

ALARM2	  MOVLW		.10					;THIS SET THE TIME FOR ALARMING
		  MOVWF		COUNT2				;LOAD


ALARMA	  BCF		OUT					;TURN ON SPEAKER
		  CALL		BUZZ				;DELAY
		  BSF		OUT					;TURN OFF SPEAKER
		  CALL		BUZZ				;DELAY
		  DECFSZ	COUNT1,1			;ALARM FOR 1 SECONDS
		  GOTO		ALARMA				;JUMP
		  DECFSZ	COUNT2,1			;DELAY
		  GOTO		ALARMA				;REPEAT
		  BSF		OUT				    ;TURN OFF SPEAKER
		  GOTO		CHECK				;RETURN

BUZZ	  MOVLW		.4					;DELAYS FOR 4kHZ
		  MOVWF		COUNT5
		  MOVLW		.79
		  MOVWF		COUNT4
B1		  DECFSZ	COUNT4,1
		  GOTO		B1
		  MOVLW		.79
		  MOVWF		COUNT4		  
		  DECFSZ	COUNT5,1
		  GOTO		B1
 		  RETURN


		END			;END OF PROGRAM